local class_name = "Close_The_Door"

if not rawget(_G, class_name) then
	rawset(_G, class_name, {
		door_units = { --hold_open_the_safe 
			["pick_lock_hard_no_skill"] = {
				--["@ID79991727a2679722@"] = {close_sequence = "anim_close_door", is_close = false}, --deposit box, no close anim :(
				["@IDe653b95736abc583@"] = {close_sequence = "anim_close_door", is_close = false}, --iron door (universal)
				["@IDb68beff56b10a9fd@"] = {close_sequence = "anim_close_door", is_close = false}, --yet another iron door (based on ShadowRaid)
				["@ID6f05dea8c859aab9@"] = {close_sequence = "anim_close_door", is_close = false}, --wooden door from WH, West wing
				["@ID1d283db01fc4a72b@"] = {close_sequence = "state_door_close", is_close = false}, --wooden apartment's door white (doesn't work)
				["@IDcfb8d38ad0edaedb@"] = {close_sequence = "door_closed", is_close = false}, --windowed iron door from mexican camp
				["@IDab54c8b618486ddb@"] = {close_sequence = "close", is_close = false}, --White House wooden door tall
				["@ID0e2cd454f5ee8bfa@"] = {close_sequence = "close", is_close = false}, --White House wooden door white
				["@IDe024820580f854e2@"] = {close_sequence = "anim_close_door", is_close = false}, --white wooden door from Counterfeint
				["@ID559c3e4ebf3b32f3@"] = {close_sequence = "anim_close_door", is_close = false} --windowed metallic door from Museum basement - security
			},
			["pick_lock_hard_no_skill_deactivated"] = {
				["@ID645fad32c1eabd6b@"] = {close_sequence = "state_door_close", is_close = false} --janitor's green door in Alesso arena
			},
			["open_door"] = {
				["@ID4607b6829da8b931@"] = {close_sequence = "anim_close_door", is_close = false} --wooden apartment's door dark
			},
			["pick_lock_easy_no_skill"] = {
				["@ID08a33537c9d0673a@"] = {close_sequence = "anim_close_door", is_close = false}, --wooden door (universal)
				["@ID851f3239dec9d210@"] = {close_sequence = "anim_close_door", is_close = false}, --double glass metallic door
				["@ID18a7caca12899b38@"] = {close_sequence = "anim_close_door", is_close = false}, --glass metallic door
				["@ID985d76ced36deacf@"] = {close_sequence = "state_door_close", is_close = false}, --wooden door in Scarface mansion garden shed
				["@IDc0a49d70d9725387@"] = {close_sequence = "anim_close", is_close = false}, --yacht's apartment door
				["@IDb43c26feb159eef7@"] = {close_sequence = "anim_close_door", is_close = false}, --wooden door in OVK border clubhouse
				["@IDc3419d4bf5de2647@"] = {close_sequence = "state_door_closed", is_close = false}, --wooden casino door in serivce area
				["@IDa25106db58e693fc@"] = {close_sequence = "close_in", is_close = false},	--chainlink fence double gate
				["@IDa25106db58e693fc@"] = {close_sequence = "close_out", is_close = false}, --chainlink fence double gate
				["@ID574bab205ffb92e4@"] = {close_sequence = "state_door_close", is_close = false}, --white windowed entrance door in White House
				["@IDbcd14bda3bb56c81@"] = {close_sequence = "anim_close_door", is_close = false}, --museum, door+window big - entrance
				["@ID9f86c1d142c90206@"] = {close_sequence = "anim_close_door", is_close = false}, --windowed metallic door from Museum basement
				["@ID5eb73ede6ece6c9d@"] = {close_sequence = "anim_close_door", is_close = false} --2nd windowed metallic door from Museum basement	
			},
			--["suburbia_door_crowbar"] = {
			--	["@IDe024820580f854e2@"] = {close_sequence = "b_closed", is_close = false} --mr. Mitchell's basement door at Counterfeint --what anim to use??
			--},
			["open_from_inside"] = {
				["@ID4407f5e571e2f51a@"] = {close_sequence = "state_door_close", owrite_axis = true, is_close = false} --metallic door with keypad (universal)
			},
			["open_door_with_keys"] = {
				["@ID5e6cf74e25cfe207@"] = {close_sequence = "state_door_close", is_close = false}, --fence door vault internal - branchbank (vanilla)
				["@ID2b4644aac7aa9aa0@"] = {close_sequence = "state_door_close", is_close = false}, --fence door vault internal - branchbank (firestarter)
				["@ID1de4ed810c20491c@"] = {close_sequence = "close_door", is_close = false} --fence door security corridor - casino ???
			},
			["atm_interaction"] = {
				["@ID391916f9100c4b3f@"] = {close_sequence = "anim_door_close", is_close = false} --container (universal)
			},
			["invisible_interaction_open"] = {
				["@IDcacb98c495c63475@"] = {close_sequence = "anim_door_close", is_close = false}, --keybox (they doesn't work)
				["@ID5ea07191b3854701@"] = {close_sequence = "anim_door_close", is_close = false} --keybox 2
			},
			["hold_search_shower"] = {
				["@IDdd0f26b932b13d62@"] = {close_sequence = "anim_close_door", is_close = false} --yacht's shower door
			},
			["shelf_sliding_suburbia"] = {
				["@ID64b82ecfc00c51c4@"] = {close_sequence = "close", is_close = false} --slideable bookshelf in basements of Counterfeint
			},
			["suburbia_iron_gate_crowbar"] = {
				["@IDb5f976563eb26515@"] = {close_sequence = "close", is_close = false} --fence door in Basement of Counterfeint
			},
			["pick_lock_hard"] = {
				["@ID3e964910f730f3d7@"] = {close_sequence = "state_door_close", is_close = false}, --big safe black (all doesn't work)
				["@IDd2e9092f3a57cefc@"] = {close_sequence = "state_door_close", is_close = false}, --medium/small safe black
				["@ID8834e3a4da3df5c6@"] = {close_sequence = "state_door_close", is_close = false} --big safe tall black
			},
			["pick_lock_30"] = {
				["@IDfbf379ad311ef40d@"] = {close_sequence = "close_door", is_close = false}, --wooden casino door double
				["@IDc64fa142f6d098b5@"] = {close_sequence = "close_door", is_close = false} --wooden casino door single
			},
			["hospital_security_cable_blue"] = { --check opening anim
				["@ID70b58117ca5ff0f4@"] = {close_sequence = "close_box", is_close = false} --security wiring box (Mercy hospital)
			},
			["lockpick_locker"] = {
				["@IDea4c3c264006fd13@"] = {close_sequence = "close_door", is_close = false} --blue locker unit (universal)
			}
		}
	}) --vit_keycard_use @ID86703455b619528f@ ??
end	--pick_lock_hard_no_skill @IDcfffc73d99a0b3ce@ no close anim

local c = _G[class_name]
local req_script = table.remove(RequiredScript:split("/"))
local orig_axis_data = nil
local host = Network:is_server()

c._get_timer = function()
	return 0.125
end

function c:can_interact_unit(door_unit, unit_damage)
	local close = door_unit.close_sequence
	if close and unit_damage:has_sequence(close) then
		return close
	end
end

function c:run_sequence(unit_damage, unit, sequence, player)
	unit_damage:run_sequence_simple(sequence, {unit = player})
	local session = managers.network and managers.network:session()
	if session then
		session:send_to_peers_synched("run_mission_door_sequence", unit, sequence)			--sync base
		session:send_to_peers_synched("run_mission_door_device_sequence", unit, sequence)	--sync damage
	end
end

--remove axis
function c:disable_axis(door_unit, interaction)
	if door_unit.owrite_axis and interaction._tweak_data and interaction._tweak_data.axis then
		orig_axis_data = {tweak = interaction._tweak_data.axis, axis = interaction._interact_axis}
		interaction._tweak_data.axis = nil
		interaction._interact_axis = nil
	end
end

--restore axis
function c:enable_orig_axis(door_unit, interaction)
	if door_unit.owrite_axis and orig_axis_data then
		interaction._tweak_data.axis = orig_axis_data.tweak
		interaction._interact_axis = orig_axis_data.axis
	end
end
	
if string.lower(req_script) == string.lower("objectinteractionmanager") and _G["ObjectInteractionManager"] ~= nil then
	--open door
	local orig_func_interact = ObjectInteractionManager.interact
	function ObjectInteractionManager:interact(player, data, hand_id)
		local interacted, timer, unit = orig_func_interact(self, player, data, hand_id)
		local interaction = (alive(unit) and (unit['interaction'] ~= nil)) and unit:interaction()
		if interaction and type(interaction.tweak_data) == "string" then
			local units = c.door_units[interaction.tweak_data]
			local door_unit = units and units[unit:name():t()]
			if timer and door_unit and door_unit.is_close then
				--disable interaction? Remove hud elements here
				local unit_base = unit:base() and unit:base()._devices
				if unit_base then
					local can_place_device = interaction.server_place_mission_door_device and interaction:server_place_mission_door_device(player)
					local door_got_c4 = unit_base["c4"] ~= nil
					local door_got_drill = unit_base["drill"] ~= nil
					local door_got_key = unit_base["key"] ~= nil
					local door_got_ecm = unit_base["ecm"] ~= nil
					if can_place_device and (door_got_c4 or door_got_drill or door_got_key or door_got_ecm) then
						return
					end
				end

				door_unit.is_close = false
				c:enable_orig_axis(door_unit, interaction)
			end
		end
		return interacted, timer, unit
	end
elseif string.lower(req_script) == string.lower("playerstandard") and _G["PlayerStandard"] ~= nil then
	--close door
	local twk_func_do_action_melee = PlayerStandard._do_action_melee
	function PlayerStandard:_do_action_melee(t, ...)
		local _col_ray = self:_calc_melee_hit_ray(t, 20)
		if _col_ray and alive(self._unit) then
			local unit = _col_ray.unit
			local interaction = (alive(unit) and (unit['interaction'] ~= nil)) and unit:interaction()
			if interaction and type(interaction.tweak_data) == "string" then
				local units = c.door_units[interaction.tweak_data]
				local door_unit = units and units[unit:name():t()]
				local unit_damage = unit:damage()
				if door_unit and unit_damage and not interaction:active() then
					local sequence = c:can_interact_unit(door_unit, unit_damage)
					if sequence then
						door_unit.is_close = true
						
						c:run_sequence(unit_damage, unit, sequence, self._unit)	--close the door and sync it
						
						interaction:set_active(true, true)						--make doors interactable on close and sync it
						interaction._get_timer = c._get_timer					--set new door interaction timer for user only
						
						c:disable_axis(door_unit, interaction)					--can interact from any angle
					end
				end
			end
		end
		twk_func_do_action_melee(self, t, ...)
	end
elseif string.lower(req_script) == string.lower("UnitNetworkHandler")and _G["UnitNetworkHandler"] ~= nil then
	--check player interacting with door that are closed by melee and set/change interaction timer for other players
	local orig_func_sync_teammate_progress = UnitNetworkHandler.sync_teammate_progress
	function UnitNetworkHandler:sync_teammate_progress(type_index, enabled, tweak_data_id, timer, success, sender)
		local peer = self._verify_sender(sender)
		if host and peer and enabled and not success and type(tweak_data_id) == "string" and timer then
			local all_units = c.door_units[tweak_data_id]
			if all_units then
				for _, unit in pairs(managers.interaction._interactive_units) do
					local interaction = (alive(unit) and (unit['interaction'] ~= nil)) and unit:interaction()
					if interaction and all_units[unit:name():t()] and all_units[unit:name():t()].is_close then
						timer = 0.125
                        local strinf = string.format("%s_%s", class_name, unit:name():t())
                        DelayedCalls:Add(strinf, timer, function()
                            interaction:interact(managers.player:player_unit())
                        end)
						break
					end
				end
			end
		end
		orig_func_sync_teammate_progress(self, type_index, enabled, tweak_data_id, timer, success, sender)
	end
end